#ifndef _ATTRIBUTE_H_INCLUDED_
#define _ATTRIBUTE_H_INCLUDED_
///////////////////////////////////////////////////////////////////////////////
//
// Attribute.h
// -----------
// XML Attribute implementation
//               
// Design and Implementation by Bjoern Lemke
//
// (C)opyright 2000-2006 Bjoern Lemke
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; see the file COPYING.  If not, write to
// the Free Software Foundation, 59 Temple Place - Suite 330,
// Boston, MA 02111-1307, USA.
//
// INTERFACE MODULE
//
// Class: Attribute
// 
// Description: 
//
// Status: IMPLEMENTED
//
///////////////////////////////////////////////////////////////////////////////

// INCLUDES
#include <lfc/Chain.h>

class Attribute {
 
 public:
  
    Attribute();
    Attribute(const Chain& name);
    Attribute(const Chain& name, const Chain& value, bool treatXMLEscape = true);
     ~Attribute();
     
     const Chain& getName() const;

     Chain getXMLValue() const;
     
     void setValue(const Chain& value, bool treatXMLEscape = true);
     Chain getValue() const;

     Attribute& operator =  ( const Attribute& attr);
     bool operator == ( const Attribute& attr) const;
     
     
 private:
     
     Chain _name;
     Chain _value;
  
};

#endif

